/*============================================================================
  File:     3a_Track_Queries.sql

  SQL Server Versions: 2012 onwards
------------------------------------------------------------------------------
  Written by Erin Stellato, SQLskills.com
  
  (c) 2013, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

IF EXISTS (SELECT 1 FROM sys.server_event_sessions WHERE name = 'Track_Queries')
	DROP EVENT SESSION [Track_Queries] ON SERVER;
GO


/*
	create our event session
*/
CREATE EVENT SESSION [Track_Queries] 
	ON SERVER 
ADD EVENT sqlserver.rpc_completed (
    ACTION (
		sqlserver.database_id,sqlserver.session_nt_username)
    WHERE (
		[sqlserver].[is_system]=(0))
		),
ADD EVENT sqlserver.sp_statement_completed(
    ACTION (
		sqlserver.database_id,sqlserver.session_nt_username)
    WHERE (
		[sqlserver].[is_system]=(0))
		) 
ADD TARGET package0.ring_buffer
WITH (MAX_MEMORY=1024 KB,EVENT_RETENTION_MODE=ALLOW_SINGLE_EVENT_LOSS,
	MAX_DISPATCH_LATENCY=30 SECONDS,MAX_EVENT_SIZE=0 KB,
	MEMORY_PARTITION_MODE=NONE,TRACK_CAUSALITY=OFF,STARTUP_STATE=OFF)
GO


/*
	start it up
*/
ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	STATE=START;
	GO

--run .ps1 scripts

/*
	query the ring_buffer in a separate window
*/


/*
	alter session to stop collecting rpc_completed event
*/
ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	DROP EVENT sqlserver.rpc_completed;
	GO

/*
	alter session to stop collecting sp_statement_completed event
*/
ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	DROP EVENT sqlserver.sp_statement_completed;
	GO


/*
	query the ring_buffer again in a separate window
*/


/*
	stop the event session, then query 
	the ring_buffer one more time
*/
ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	STATE=STOP;
	GO


/*
	remove the ring_buffer target
	add event_file target
*/
ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	DROP TARGET package0.ring_buffer;
	GO

ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	ADD TARGET package0.event_file (
	SET filename=N'C:\Temp\TrackQueries.xel')
	GO


/*
	no events exist at this point...
	re-add one
*/
ALTER EVENT SESSION [Track_Queries] 
	ON SERVER 
ADD EVENT sqlserver.sp_statement_completed (
    ACTION (
		sqlserver.database_id,sqlserver.session_nt_username)
    WHERE (
		[sqlserver].[is_system]=(0))
		);
GO


/*
	restart
*/
ALTER EVENT SESSION [Track_Queries]
	ON SERVER
	STATE=Start;
	GO


/*
	could have stopped the session, dropped it, and then recreated it
*/
DROP EVENT SESSION [Track_Queries]
	ON SERVER;
	GO
   
CREATE EVENT SESSION [Track_Queries] 
	ON SERVER 
ADD EVENT sqlserver.sp_statement_completed (
    ACTION (
		sqlserver.database_id,sqlserver.session_nt_username)
    WHERE (
		[sqlserver].[is_system]=(0))
		) 
ADD TARGET package0.event_file (
	SET filename=N'C:\Temp\TrackQueries.xel')
WITH (MAX_MEMORY=1024 KB,EVENT_RETENTION_MODE=ALLOW_SINGLE_EVENT_LOSS,
MAX_DISPATCH_LATENCY=30 SECONDS,MAX_EVENT_SIZE=0 KB,
MEMORY_PARTITION_MODE=NONE,TRACK_CAUSALITY=OFF,STARTUP_STATE=OFF);
GO




