/*============================================================================
  File:     4a_Research_SP.sql

  SQL Server Versions: 2008 onwards
------------------------------------------------------------------------------
  Written by Erin Stellato, SQLskills.com
  
  (c) 2013, SQLskills.com. All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you include this copyright and give due
  credit, but you must obtain prior permission before blogging this code.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

IF EXISTS (SELECT 1 FROM sys.server_event_sessions WHERE name = 'Research_SP')
	DROP EVENT SESSION [Research_SP] ON SERVER;
GO


CREATE EVENT SESSION [Research_SP] 
	ON SERVER 
ADD EVENT sqlserver.sp_statement_completed (
    ACTION (
		sqlserver.database_id,sqlserver.session_nt_username)
    WHERE (
		[sqlserver].[is_system]=(0))
		) 
ADD TARGET package0.ring_buffer,
ADD TARGET package0.event_file (
	SET filename=N'C:\Temp\TrackQueries.xel')
WITH (MAX_MEMORY=1024 KB,EVENT_RETENTION_MODE=ALLOW_SINGLE_EVENT_LOSS,
MAX_DISPATCH_LATENCY=30 SECONDS,MAX_EVENT_SIZE=0 KB,
MEMORY_PARTITION_MODE=NONE,TRACK_CAUSALITY=OFF,STARTUP_STATE=OFF);
GO



/*
	start 
*/
ALTER EVENT SESSION [Research_SP]
	ON SERVER
	STATE=START;
	GO


/*
	run .ps1 scripts
	view targets - ring_buffer vs. event_file
	view live data
*/

SELECT *
FROM [sys].[databases]
WHERE [database_id] = 5;


USE [AdventureWorks2012];
GO

SELECT *
FROM [sys].[all_objects]
WHERE [object_id] IN (791673868)


/*
	stop session, alter it in UI to filter on object_id
*/
ALTER EVENT SESSION [Research_SP]
	ON SERVER
	STATE=STOP;
	GO


IF EXISTS (SELECT 1 FROM sys.server_event_sessions WHERE name = 'Research_SP')
	DROP EVENT SESSION [Research_SP] ON SERVER;
GO

CREATE EVENT SESSION [Research_SP] 
	ON SERVER 
	ADD EVENT sqlserver.sp_statement_completed(
		SET collect_statement=(1)
		ACTION(
			sqlserver.database_id,
			sqlserver.session_nt_username
			)
		WHERE (
			[package0].[equal_boolean]([sqlserver].[is_system],(0)
			) 
			AND [object_id]=(791673868)
			)
		) 
	ADD TARGET package0.event_file(
		SET filename=N'C:\Temp\TrackQueries.xel'
		),
	ADD TARGET package0.ring_buffer
	WITH (MAX_MEMORY=1024 KB,EVENT_RETENTION_MODE=ALLOW_SINGLE_EVENT_LOSS,MAX_DISPATCH_LATENCY=30 SECONDS,MAX_EVENT_SIZE=0 KB,MEMORY_PARTITION_MODE=NONE,TRACK_CAUSALITY=OFF,STARTUP_STATE=OFF)
GO



/*
	restart session
	start live data
	run scripts
*/
ALTER EVENT SESSION [Research_SP]
	ON SERVER
	STATE=START;
	GO

